<?php

namespace Speedex\SpeedexArray;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfConsignmentCollectOnDelivery SpeedexArray
 * @package Speedex
 * @subpackage Arrays
 */
class SpeedexArrayOfConsignmentCollectOnDelivery extends AbstractStructArrayBase
{
    /**
     * The ConsignmentCollectOnDelivery
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Speedex\SpeedexStruct\SpeedexConsignmentCollectOnDelivery[]
     */
    public $ConsignmentCollectOnDelivery;
    /**
     * Constructor method for ArrayOfConsignmentCollectOnDelivery
     * @uses SpeedexArrayOfConsignmentCollectOnDelivery::setConsignmentCollectOnDelivery()
     * @param \Speedex\SpeedexStruct\SpeedexConsignmentCollectOnDelivery[] $consignmentCollectOnDelivery
     */
    public function __construct(array $consignmentCollectOnDelivery = array())
    {
        $this
            ->setConsignmentCollectOnDelivery($consignmentCollectOnDelivery);
    }
    /**
     * Get ConsignmentCollectOnDelivery value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Speedex\SpeedexStruct\SpeedexConsignmentCollectOnDelivery[]|null
     */
    public function getConsignmentCollectOnDelivery()
    {
        return isset($this->ConsignmentCollectOnDelivery) ? $this->ConsignmentCollectOnDelivery : null;
    }
    /**
     * This method is responsible for validating the values passed to the setConsignmentCollectOnDelivery method
     * This method is willingly generated in order to preserve the one-line inline validation within the setConsignmentCollectOnDelivery method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateConsignmentCollectOnDeliveryForArrayConstraintsFromSetConsignmentCollectOnDelivery(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfConsignmentCollectOnDeliveryConsignmentCollectOnDeliveryItem) {
            // validation for constraint: itemType
            if (!$arrayOfConsignmentCollectOnDeliveryConsignmentCollectOnDeliveryItem instanceof \Speedex\SpeedexStruct\SpeedexConsignmentCollectOnDelivery) {
                $invalidValues[] = is_object($arrayOfConsignmentCollectOnDeliveryConsignmentCollectOnDeliveryItem) ? get_class($arrayOfConsignmentCollectOnDeliveryConsignmentCollectOnDeliveryItem) : sprintf('%s(%s)', gettype($arrayOfConsignmentCollectOnDeliveryConsignmentCollectOnDeliveryItem), var_export($arrayOfConsignmentCollectOnDeliveryConsignmentCollectOnDeliveryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ConsignmentCollectOnDelivery property can only contain items of type \Speedex\SpeedexStruct\SpeedexConsignmentCollectOnDelivery, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ConsignmentCollectOnDelivery value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Speedex\SpeedexStruct\SpeedexConsignmentCollectOnDelivery[] $consignmentCollectOnDelivery
     * @return \Speedex\SpeedexArray\SpeedexArrayOfConsignmentCollectOnDelivery
     */
    public function setConsignmentCollectOnDelivery(array $consignmentCollectOnDelivery = array())
    {
        // validation for constraint: array
        if ('' !== ($consignmentCollectOnDeliveryArrayErrorMessage = self::validateConsignmentCollectOnDeliveryForArrayConstraintsFromSetConsignmentCollectOnDelivery($consignmentCollectOnDelivery))) {
            throw new \InvalidArgumentException($consignmentCollectOnDeliveryArrayErrorMessage, __LINE__);
        }
        if (is_null($consignmentCollectOnDelivery) || (is_array($consignmentCollectOnDelivery) && empty($consignmentCollectOnDelivery))) {
            unset($this->ConsignmentCollectOnDelivery);
        } else {
            $this->ConsignmentCollectOnDelivery = $consignmentCollectOnDelivery;
        }
        return $this;
    }
    /**
     * Add item to ConsignmentCollectOnDelivery value
     * @throws \InvalidArgumentException
     * @param \Speedex\SpeedexStruct\SpeedexConsignmentCollectOnDelivery $item
     * @return \Speedex\SpeedexArray\SpeedexArrayOfConsignmentCollectOnDelivery
     */
    public function addToConsignmentCollectOnDelivery(\Speedex\SpeedexStruct\SpeedexConsignmentCollectOnDelivery $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Speedex\SpeedexStruct\SpeedexConsignmentCollectOnDelivery) {
            throw new \InvalidArgumentException(sprintf('The ConsignmentCollectOnDelivery property can only contain items of type \Speedex\SpeedexStruct\SpeedexConsignmentCollectOnDelivery, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ConsignmentCollectOnDelivery[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Speedex\SpeedexStruct\SpeedexConsignmentCollectOnDelivery|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Speedex\SpeedexStruct\SpeedexConsignmentCollectOnDelivery|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Speedex\SpeedexStruct\SpeedexConsignmentCollectOnDelivery|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Speedex\SpeedexStruct\SpeedexConsignmentCollectOnDelivery|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Speedex\SpeedexStruct\SpeedexConsignmentCollectOnDelivery|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ConsignmentCollectOnDelivery
     */
    public function getAttributeName()
    {
        return 'ConsignmentCollectOnDelivery';
    }
}
