<?php

namespace Speedex\SpeedexArray;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVoucherCod SpeedexArray
 * @package Speedex
 * @subpackage Arrays
 */
class SpeedexArrayOfVoucherCod extends AbstractStructArrayBase
{
    /**
     * The VoucherCod
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Speedex\SpeedexStruct\SpeedexVoucherCod[]
     */
    public $VoucherCod;
    /**
     * Constructor method for ArrayOfVoucherCod
     * @uses SpeedexArrayOfVoucherCod::setVoucherCod()
     * @param \Speedex\SpeedexStruct\SpeedexVoucherCod[] $voucherCod
     */
    public function __construct(array $voucherCod = array())
    {
        $this
            ->setVoucherCod($voucherCod);
    }
    /**
     * Get VoucherCod value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Speedex\SpeedexStruct\SpeedexVoucherCod[]|null
     */
    public function getVoucherCod()
    {
        return isset($this->VoucherCod) ? $this->VoucherCod : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVoucherCod method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVoucherCod method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVoucherCodForArrayConstraintsFromSetVoucherCod(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVoucherCodVoucherCodItem) {
            // validation for constraint: itemType
            if (!$arrayOfVoucherCodVoucherCodItem instanceof \Speedex\SpeedexStruct\SpeedexVoucherCod) {
                $invalidValues[] = is_object($arrayOfVoucherCodVoucherCodItem) ? get_class($arrayOfVoucherCodVoucherCodItem) : sprintf('%s(%s)', gettype($arrayOfVoucherCodVoucherCodItem), var_export($arrayOfVoucherCodVoucherCodItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VoucherCod property can only contain items of type \Speedex\SpeedexStruct\SpeedexVoucherCod, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VoucherCod value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Speedex\SpeedexStruct\SpeedexVoucherCod[] $voucherCod
     * @return \Speedex\SpeedexArray\SpeedexArrayOfVoucherCod
     */
    public function setVoucherCod(array $voucherCod = array())
    {
        // validation for constraint: array
        if ('' !== ($voucherCodArrayErrorMessage = self::validateVoucherCodForArrayConstraintsFromSetVoucherCod($voucherCod))) {
            throw new \InvalidArgumentException($voucherCodArrayErrorMessage, __LINE__);
        }
        if (is_null($voucherCod) || (is_array($voucherCod) && empty($voucherCod))) {
            unset($this->VoucherCod);
        } else {
            $this->VoucherCod = $voucherCod;
        }
        return $this;
    }
    /**
     * Add item to VoucherCod value
     * @throws \InvalidArgumentException
     * @param \Speedex\SpeedexStruct\SpeedexVoucherCod $item
     * @return \Speedex\SpeedexArray\SpeedexArrayOfVoucherCod
     */
    public function addToVoucherCod(\Speedex\SpeedexStruct\SpeedexVoucherCod $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Speedex\SpeedexStruct\SpeedexVoucherCod) {
            throw new \InvalidArgumentException(sprintf('The VoucherCod property can only contain items of type \Speedex\SpeedexStruct\SpeedexVoucherCod, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VoucherCod[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Speedex\SpeedexStruct\SpeedexVoucherCod|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Speedex\SpeedexStruct\SpeedexVoucherCod|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Speedex\SpeedexStruct\SpeedexVoucherCod|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Speedex\SpeedexStruct\SpeedexVoucherCod|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Speedex\SpeedexStruct\SpeedexVoucherCod|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VoucherCod
     */
    public function getAttributeName()
    {
        return 'VoucherCod';
    }
}
