<?php

namespace Speedex\SpeedexArray;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVoucherPNG SpeedexArray
 * @package Speedex
 * @subpackage Arrays
 */
class SpeedexArrayOfVoucherPNG extends AbstractStructArrayBase
{
    /**
     * The VoucherPNG
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Speedex\SpeedexStruct\SpeedexVoucherPNG[]
     */
    public $VoucherPNG;
    /**
     * Constructor method for ArrayOfVoucherPNG
     * @uses SpeedexArrayOfVoucherPNG::setVoucherPNG()
     * @param \Speedex\SpeedexStruct\SpeedexVoucherPNG[] $voucherPNG
     */
    public function __construct(array $voucherPNG = array())
    {
        $this
            ->setVoucherPNG($voucherPNG);
    }
    /**
     * Get VoucherPNG value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Speedex\SpeedexStruct\SpeedexVoucherPNG[]|null
     */
    public function getVoucherPNG()
    {
        return isset($this->VoucherPNG) ? $this->VoucherPNG : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVoucherPNG method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVoucherPNG method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVoucherPNGForArrayConstraintsFromSetVoucherPNG(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVoucherPNGVoucherPNGItem) {
            // validation for constraint: itemType
            if (!$arrayOfVoucherPNGVoucherPNGItem instanceof \Speedex\SpeedexStruct\SpeedexVoucherPNG) {
                $invalidValues[] = is_object($arrayOfVoucherPNGVoucherPNGItem) ? get_class($arrayOfVoucherPNGVoucherPNGItem) : sprintf('%s(%s)', gettype($arrayOfVoucherPNGVoucherPNGItem), var_export($arrayOfVoucherPNGVoucherPNGItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VoucherPNG property can only contain items of type \Speedex\SpeedexStruct\SpeedexVoucherPNG, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VoucherPNG value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Speedex\SpeedexStruct\SpeedexVoucherPNG[] $voucherPNG
     * @return \Speedex\SpeedexArray\SpeedexArrayOfVoucherPNG
     */
    public function setVoucherPNG(array $voucherPNG = array())
    {
        // validation for constraint: array
        if ('' !== ($voucherPNGArrayErrorMessage = self::validateVoucherPNGForArrayConstraintsFromSetVoucherPNG($voucherPNG))) {
            throw new \InvalidArgumentException($voucherPNGArrayErrorMessage, __LINE__);
        }
        if (is_null($voucherPNG) || (is_array($voucherPNG) && empty($voucherPNG))) {
            unset($this->VoucherPNG);
        } else {
            $this->VoucherPNG = $voucherPNG;
        }
        return $this;
    }
    /**
     * Add item to VoucherPNG value
     * @throws \InvalidArgumentException
     * @param \Speedex\SpeedexStruct\SpeedexVoucherPNG $item
     * @return \Speedex\SpeedexArray\SpeedexArrayOfVoucherPNG
     */
    public function addToVoucherPNG(\Speedex\SpeedexStruct\SpeedexVoucherPNG $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Speedex\SpeedexStruct\SpeedexVoucherPNG) {
            throw new \InvalidArgumentException(sprintf('The VoucherPNG property can only contain items of type \Speedex\SpeedexStruct\SpeedexVoucherPNG, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VoucherPNG[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Speedex\SpeedexStruct\SpeedexVoucherPNG|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Speedex\SpeedexStruct\SpeedexVoucherPNG|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Speedex\SpeedexStruct\SpeedexVoucherPNG|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Speedex\SpeedexStruct\SpeedexVoucherPNG|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Speedex\SpeedexStruct\SpeedexVoucherPNG|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VoucherPNG
     */
    public function getAttributeName()
    {
        return 'VoucherPNG';
    }
}
