<?php

namespace Speedex\SpeedexStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetDepositedConsignmentsByDateResult SpeedexStruct
 * @package Speedex
 * @subpackage Structs
 */
class SpeedexGetDepositedConsignmentsByDateResult extends AbstractStructBase
{
    /**
     * The StatusCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $StatusCode;
    /**
     * The Message
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Message;
    /**
     * The Result
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Speedex\SpeedexArray\SpeedexArrayOfConsignmentCollectOnDelivery
     */
    public $Result;
    /**
     * Constructor method for GetDepositedConsignmentsByDateResult
     * @uses SpeedexGetDepositedConsignmentsByDateResult::setStatusCode()
     * @uses SpeedexGetDepositedConsignmentsByDateResult::setMessage()
     * @uses SpeedexGetDepositedConsignmentsByDateResult::setResult()
     * @param int $statusCode
     * @param string $message
     * @param \Speedex\SpeedexArray\SpeedexArrayOfConsignmentCollectOnDelivery $result
     */
    public function __construct($statusCode = null, $message = null, \Speedex\SpeedexArray\SpeedexArrayOfConsignmentCollectOnDelivery $result = null)
    {
        $this
            ->setStatusCode($statusCode)
            ->setMessage($message)
            ->setResult($result);
    }
    /**
     * Get StatusCode value
     * @return int
     */
    public function getStatusCode()
    {
        return $this->StatusCode;
    }
    /**
     * Set StatusCode value
     * @param int $statusCode
     * @return \Speedex\SpeedexStruct\SpeedexGetDepositedConsignmentsByDateResult
     */
    public function setStatusCode($statusCode = null)
    {
        // validation for constraint: int
        if (!is_null($statusCode) && !(is_int($statusCode) || ctype_digit($statusCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($statusCode, true), gettype($statusCode)), __LINE__);
        }
        $this->StatusCode = $statusCode;
        return $this;
    }
    /**
     * Get Message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->Message;
    }
    /**
     * Set Message value
     * @param string $message
     * @return \Speedex\SpeedexStruct\SpeedexGetDepositedConsignmentsByDateResult
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($message, true), gettype($message)), __LINE__);
        }
        $this->Message = $message;
        return $this;
    }
    /**
     * Get Result value
     * @return \Speedex\SpeedexArray\SpeedexArrayOfConsignmentCollectOnDelivery|null
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param \Speedex\SpeedexArray\SpeedexArrayOfConsignmentCollectOnDelivery $result
     * @return \Speedex\SpeedexStruct\SpeedexGetDepositedConsignmentsByDateResult
     */
    public function setResult(\Speedex\SpeedexArray\SpeedexArrayOfConsignmentCollectOnDelivery $result = null)
    {
        $this->Result = $result;
        return $this;
    }
}
